
unit ASWSMain;

interface

uses
  Windows, Forms, WSocket, StdCtrls, Buttons, Controls, ExtCtrls, ComCtrls,
  Classes, Menus, Dialogs, RxTray, LCDate;

const
  MyVer	= $00005000;	// server version! (0.5)

type
  tsState = (ssStopped, ssWorking, ssIdle);

  TF_ASWSMain = class(TForm)
    SS: TWSocket;
    SB1: TStatusBar;
    PC1: TPageControl;
    TS1: TTabSheet;
    TS2: TTabSheet;
    OD1: TOpenDialog;
    TS3: TTabSheet;
    pgLB: TListBox;
    TS4: TTabSheet;
    M1: TMemo;
    M2: TMemo;
    RxTray1: TRxTray;
    Button8: TButton;
    P2: TPanel;
    Label9: TLabel;
    E7: TEdit;
    Label10: TLabel;
    E8: TEdit;
    Label11: TLabel;
    E9: TEdit;
    B7: TButton;
    B9: TButton;
    B10: TButton;
    Panel1: TPanel;
    StopBtn: TButton;
    ListenBtn: TButton;
    B6: TButton;
    PM2: TPopupMenu;
    Start1: TMenuItem;
    Stop1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    PC2: TPageControl;
    TS5: TTabSheet;
    TS6: TTabSheet;
    MimeLB: TListBox;
    GB1: TGroupBox;
    CB1: TCheckBox;
    CB2: TCheckBox;
    CB4: TCheckBox;
    GB2: TGroupBox;
    Label8: TLabel;
    Edit6: TEdit;
    SpeedButton4: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Edit3: TEdit;
    Label5: TLabel;
    Label4: TLabel;
    Edit2: TEdit;
    SpeedButton3: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    Label3: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    GB3: TGroupBox;
    Label12: TLabel;
    Edit10: TEdit;
    Edit11: TEdit;
    Label13: TLabel;
    CSock: TWSocket;
    Edit12: TEdit;
    CB5: TCheckBox;
    SpeedButton5: TSpeedButton;
    LCDate1: TLCDate;
    B11: TButton;
    B4: TButton;
    Edit13: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit14: TEdit;
    Label14: TLabel;
    SpeedButton6: TSpeedButton;
    Edit15: TEdit;
    Label15: TLabel;
    CB3: TCheckBox;
    Settings1: TMenuItem;
    B12: TButton;
    M3: TMemo;
    Splitter1: TSplitter;
    procedure ListenBtnClick(Sender: TObject);
    procedure SSChangeState(Sender: TObject; OldState,
      NewState: TSocketState);
    procedure SSSessionAvailable(Sender: TObject; Error: Word);
    procedure StopBtnClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure B4Click(Sender: TObject);
    function GetMIME: string;
    procedure SpeedButton3Click(Sender: TObject);
    procedure B6Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure RxTray1Click(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure B9Click(Sender: TObject);
    procedure CSockChangeState(Sender: TObject; OldState,
      NewState: TSocketState);
    procedure B7Click(Sender: TObject);
    procedure B10Click(Sender: TObject);
    procedure CSockDataAvailable(Sender: TObject; Error: Word);
    procedure Start1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure NotYet;
    procedure SaveSettings;
    function  RestoreSettings: Boolean;
    procedure B11Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure B12Click(Sender: TObject);
    procedure PC2Change(Sender: TObject);
  private
    { Private declarations }
    fState : tsState;
    fExts,
    fStrs  : tStrings;
    wasInit: Boolean;
    fRequests: Integer;
    function GetDoNotShow: Boolean;
    function GetAutoClose: Boolean;
    function GetBasePath: string;
    function GetBaseFile: string;
    procedure SetStatus(const aValue: string);
    procedure SetClientsNum(aValue: Integer);
    procedure SetState(aValue: tsState);
    function GetExt(const aExt: string): string;
    procedure SetExt(const aExt, aValue: string);
    procedure LoadMimeDatabase;
    function SelectPath(aEdit: tEdit; const aTitle: string): Boolean;
    function GetHeader: string;
    function GetFooter: string;
    procedure RestoreAndShow;
  public
    { Public declarations }
    fServerStr: string;
    //
    procedure DoStop;
    procedure DoStart;
    procedure LoadPlugins;
    procedure FreePlugins(aCloseInfo: Integer);
    //
    property DoNotShow: Boolean read GetDoNotShow;
    property AutoClose: Boolean read GetAutoClose;
    property BasePath: string read GetBasePath;
    property BaseFile: string read GetBaseFile;
    property Status: string write SetStatus;
    property ClientsNum: Integer write SetClientsNum;
    property State: tsState read fState write SetState;
    property MimeExtension[const Extension: string]: string read GetExt write SetExt;
    property Footer: string read GetFooter;
    property Header: string read GetHeader;
  end;

var
  F_ASWSMain: TF_ASWSMain;

implementation

uses
  SysUtils, ASWSMClient, HomeTool, ASWSPlugin, Registry;

{$R *.DFM}

const
  regAppName = 'ASWS';	// App name for registry keys
  regSettings= '\Settings';
  regAppSet  = regAppName + regSettings;
  regCBoxes  = 'CBoxes';
  regEditx   = 'Edit';

procedure tF_ASWSMAin.DoStart;
begin
  with SS do begin
    Port := Edit4.Text;
    Addr := '0.0.0.0';
    try
      Listen;
    except
      on E:Exception do ShowMessage('Unable to listen: ' + E.Message);
    end;
  end;
end;

procedure TF_ASWSMain.ListenBtnClick(Sender: TObject);
begin
  DoStart;
end;

const
  ss2Str: array[TSocketState] of string = (
    'InvalidState', 'Opened', 'Bound', 'Connecting', 'Connected',
    'Accepting', 'Listening', 'Stopped');

procedure TF_ASWSMain.SSChangeState(Sender: TObject; OldState, NewState: TSocketState);
begin
  if not (csDestroying in ComponentState) then begin
    Caption := 'Server: ' + ss2Str[NewState];
    RxTray1.Hint := Caption;
    CB3.Checked := False;
    case NewState of
      wsInvalidState	: State := ssStopped;
      wsOpened,
      wsBound,
      wsConnecting,
      wsConnected,
      wsAccepting	: State := ssWorking;
      wsListening	: begin
	CB3.Checked := True;
	State := ssIdle;
	RxTray1.Hint := RxTray1.Hint + ' on port ' + Edit4.Text;
      end;
      wsClosed		: State := ssStopped;
    end;
  end;
  case NewState of
    wsListening: LoadPlugins;
    wsOpened,
    wsBound,
    wsConnecting,
    wsConnected,
    wsAccepting: ;
    else FreePlugins(ciClosed);
  end;
end;

procedure TF_ASWSMain.SSSessionAvailable(Sender: TObject; Error: Word);
begin
  // We need to accept the client connection
  NewPeer(SS.Accept, BasePath, BaseFile);
  Inc(fRequests);
  SB1.Panels[1].Text := 'Requests: ' + IntToStr(fRequests);
end;

function tF_ASWSMain.GetDoNotShow: Boolean;
begin
  Result := not CB1.Checked;
end;

function tF_ASWSMain.GetAutoClose: Boolean;
begin
  Result := CB2.Checked;
end;

function tF_ASWSMain.GetBasePath: string;
begin
  Result := AddBackSlash(Edit1.Text);
end;

function tF_ASWSMain.GetBaseFile: string;
begin
  Result := Edit2.Text;
end;

procedure tF_ASWSMain.SetStatus(const aValue: string);
begin
  SB1.Panels[2].Text := aValue;
end;

procedure tF_ASWSMain.SetClientsNum(aValue: Integer);
begin
  SB1.Panels[0].Text := 'Clients: ' + IntToStr(aValue);
end;

const
  MimePath = 'Mime\Database\Content Type\';

procedure tF_ASWSMain.LoadMimeDatabase;
var
  KeyNames: tStrings;
	 i: Integer;
  KeyValue: string;
begin
  fExts.Clear;
  fStrs.Clear;
  MimeLB.Sorted := False;
  MimeLB.Items.Clear;
  with tRegistry.Create do try;
    RootKey := HKEY_CLASSES_ROOT;
    KeyNames := tStringList.Create;
    with KeyNames do try
      // at first, look at all extesions in 'HKEY_CLASSES_ROOT'
      if OpenKey('', False) then begin
	GetKeyNames(KeyNames);
	CloseKey;
	i := 0;
	while (i < KeyNames.Count) do begin
	  {$b-}
	  if (Pos('.', KeyNames[i]) = 1) and OpenKey(KeyNames[i], False) then begin
	    KeyValue := ReadString('Content Type');
	    CloseKey;
	    if (KeyValue <> '') then MimeExtension[KeyNames[i]] := KeyValue;
	  end;
	  Inc(i);
	end;
      end;
      // and now load keys from "Mime\Database\Content Type\"
      if OpenKey(MimePath, False) then begin
	GetKeyNames(KeyNames);
	CloseKey;
	for i := 0 to KeyNames.Count - 1 do
	  if OpenKey(MimePath + KeyNames[i], False) then begin
	    MimeExtension[ReadString('Extension')] := KeyNames[i];
	    CloseKey;
	  end;
      end;
    finally
      Free;
    end;
  finally
    Free;
    MimeLB.Sorted := True;
  end;
end;

procedure tF_ASWSMain.DoStop;
begin
  SS.Close;
end;

procedure TF_ASWSMain.StopBtnClick(Sender: TObject);
begin
  DoStop;
end;

procedure tF_ASWSMain.SetState(aValue: tsState);
begin
  if (fState <> aValue) then begin
    fState := aValue;
    StopBtn.Enabled := False;
    ListenBtn.Enabled := False;
    case aValue of
      ssWorking	: ;
      ssStopped	: ListenBtn.Enabled := True;
      ssIdle	: StopBtn.Enabled := True;
    end;
    Start1.Enabled := ListenBtn.Enabled;
    Stop1.Enabled  := StopBtn.Enabled;
  end;
end;

function GetName(const aDefName, aNewName: string): string;
begin
  if (aNewName = '') then Result := AddBackSlash(aDefName)
		     else Result := AddBackSlash(aNewName);
end;

procedure TF_ASWSMain.SpeedButton1Click(Sender: TObject);
begin
  SelectPath(Edit1, 'Select base folder');
end;

procedure TF_ASWSMain.SpeedButton2Click(Sender: TObject);
begin
  SelectPath(Edit3, 'Select temporary folder');
end;

function tF_ASWSMain.GetExt(const aExt: string): string;
var
  i: Integer;
  NormExt: string;
begin
  Result := '';
  NormExt := Trim(UpperCase(aExt));
  if (NormExt <> '') then begin
    if (NormExt[1] = '.') then Delete(NormExt, 1, 1);
    i := fExts.IndexOf(NormExt);
    if (i >= 0) then Result := fStrs[i]
  end;
end;

procedure tF_ASWSMain.SetExt(const aExt, aValue: string);
var
  i: Integer;
  NormExt: string;
begin
  NormExt := Trim(UpperCase(aExt));
  if (NormExt <> '') then begin
    if (NormExt[1] = '.') then Delete(NormExt, 1, 1);
    i := fExts.IndexOf(NormExt);
    if (i < 0) then begin
      fExts.Add(NormExt);
      fStrs.Add(aValue);
      MimelB.Items.Add(NormExt + ' --> ' + aValue);
    end
    else begin
      fStrs[i] := aValue;
      MimeLB.Items[i] := NormExt + ' --> ' + aValue;
    end;
  end;
end;

procedure TF_ASWSMain.FormCreate(Sender: TObject);
begin
  regRootKey := HKEY_LOCAL_MACHINE;
  RxTray1.Icon.Assign(Application.Icon);
  fServerStr := IntToStr(myVer shr 16) + '.' + IntToStr(myVer shr 12);
  M3.Text := 'ASWSm - Multithreaded Personal Web Server by Alek Shamrai (alexsh@adm.univd.kharkov.ua)'#13#10 +
	     'WSocket component by Franois PIETTE (http://www.rtfm.be/fpiette)'#13#10 +
	     'Version ' + fServerStr + ' (Last compilation: ' + DateTimeToStr(LCDate1.LCDate) + ')'#13#10 +
	     'Plugins level: 2'#13#10#13#10;
  fServerStr := 'ASWSm/' + fServerStr;
  fExts := tStringList.Create;
  fStrs := tStringList.Create;
  RegLoadControl(Self, regAppName);
  if RestoreSettings then PC1.ActivePage := TS1
  else begin
    PC1.ActivePage := TS2;
    PC2.ActivePage := TS5;
    B11.Enabled := False;
  end;
  E7.Text := GetRegStr(regAppName, 'Edit7', '192.168.1.1');
  E8.Text := GetRegStr(regAppName, 'Edit8', '8080');
  E9.Text := GetRegStr(regAppName, 'Edit9', '600');
  wasInit := False;
  if CB3.Checked then DoStart;
end;

procedure TF_ASWSMain.FormDestroy(Sender: TObject);
begin
  RegSaveControl(Self, regAppName);
  SetRegStr(regAppName, 'Edit7', E7.Text);
  SetRegStr(regAppName, 'Edit8', E8.Text);
  SetRegStr(regAppName, 'Edit9', E9.Text);
  FreePlugins(ciDestroy);
  fExts.Free;
  fStrs.Free;
end;

function tF_ASWSMain.GetMIME: string;
var
  i: Integer;
begin
  Result := '';
  for i := 0 to fExts.Count - 1 do
    Result := Result + '"' + fExts[i] + '"="' + fStrs[i] + '"@';
end;

procedure tF_ASWSMain.SaveSettings;
var
  lS: string;
begin
  lS := '00000';
  if CB1.Checked then lS[1] := '1';
  if CB2.Checked then lS[2] := '1';
  if CB5.Checked then lS[3] := '1';
  if CB4.Checked then lS[4] := '1';
  if CB3.Checked then lS[5] := '1';
  SetRegStr(regAppSet, regCBoxes, lS);
  //
  SetRegStr(regAppSet, regEditx + '1',  Edit1.Text);
  SetRegStr(regAppSet, regEditx + '2',  Edit2.Text);
  SetRegStr(regAppSet, regEditx + '3',  Edit3.Text);
  SetRegStr(regAppSet, regEditx + '4',  Edit4.Text);
  SetRegStr(regAppSet, regEditx + '6',  Edit6.Text);
  SetRegStr(regAppSet, regEditx + '10', Edit10.Text);
  SetRegStr(regAppSet, regEditx + '11', Edit11.Text);
  SetRegStr(regAppSet, regEditx + '12', Edit12.Text);
  SetRegStr(regAppSet, regEditx + '13', Edit13.Text);
  SetRegStr(regAppSet, regEditx + '14', Edit14.Text);
  SetRegStr(regAppSet, regEditx + '15', Edit15.Text);
end;

function tF_ASWSMain.RestoreSettings: Boolean;
var
  lS: string;
begin
  lS := GetRegStr(regAppSet, regCBoxes, '');
  if (Length(lS) < 4) then begin
    lS := lS + '01000';
    Result := False;
  end
  else Result := True;
  CB1.Checked := (lS[1] = '1');
  CB2.Checked := (lS[2] = '1');
  CB5.Checked := (lS[3] = '1');
  CB4.Checked := (lS[4] = '1');
  CB3.Checked := (lS[5] = '1');
  Edit1.Text  := GetRegStr(regAppSet, regEditx +  '1', 'C:\Webbase\');
  Edit2.Text  := GetRegStr(regAppSet, regEditx +  '2', 'Index.Htm');
  Edit3.Text  := GetRegStr(regAppSet, regEditx +  '3', 'C:\Windows\Temp\');
  Edit4.Text  := GetRegStr(regAppSet, regEditx +  '4', '80');
  Edit6.Text  := GetRegStr(regAppSet, regEditx +  '6', 'C:\Webbase\Plugins\');
  Edit10.Text := GetRegStr(regAppSet, regEditx + '10', '<html><body bgcolor=#c0c0c0>');
  Edit11.Text := GetRegStr(regAppSet, regEditx + '11', '<center><hr>Home page of <a href=http://192.168.2.22>Alek</a></body></center></html>');
  Edit12.Text := GetRegStr(regAppSet, regEditx + '12', 'C:\Webbase\ASWS.Log');
  Edit13.Text := GetRegStr(regAppSet, regEditx + '13', '40');
  Edit14.Text := GetRegStr(regAppSet, regEditx + '14', 'C:\Webbase\Uploads\');
  Edit15.Text := GetRegStr(regAppSet, regEditx + '15', 'I_Am_The_Master');
  LoadMimeDatabase;
end;

procedure TF_ASWSMain.B4Click(Sender: TObject);
begin
  SaveSettings;
  B11.Enabled := True;
end;

procedure TF_ASWSMain.SpeedButton3Click(Sender: TObject);
begin
  OD1.InitialDir := BasePath;
  if OD1.Execute then begin
    if (Pos(BasePath, OD1.FileName) <> 1) then ShowMessage('Invalid path')
					  else Edit2.Text := Copy(OD1.FileName, Length(BasePath) + 1, 256);
  end;
end;

procedure TF_ASWSMain.B6Click(Sender: TObject);
begin
  Hide;
end;

procedure tF_ASWSMain.NotYet;
begin
  ShowMessage('Not done.');
end;

function tF_ASWSMain.SelectPath(aEdit: tEdit; const aTitle: string): Boolean;
var
  lS: string;
begin
  lS :=  SelectFolder(Handle, '', aTitle);
  if (lS <> '') then begin
    aEdit.Text := GetName(aEdit.Text, lS);
    Result := True;
  end
  else Result := False;
end;

procedure TF_ASWSMain.SpeedButton4Click(Sender: TObject);
begin
  SelectPath(Edit6, 'Select folder for plugins')
end;

procedure TF_ASWSMain.LoadPlugins;
var
  lF : Integer;
  lSR: tSearchRec;
  lST: string;
  lSN: string;
begin
  if not wasInit then begin
    StartupServer(myVer);
    lF := FindFirst(AddBackSlash(Edit6.Text) + '*.DLL', faReadOnly + faArchive, lSR);
    try
      while (lF = 0) do begin
	if (InitPlugin(AddBackSlash(Edit6.Text) + lSR.Name, lSN, lST) >= 0) then pgLB.Items.Add(lSN + ' ==> ' + lST);
	lF := FindNext(lSR);
      end;
    finally
      FindClose(lSR);
    end;
    wasInit := True;
  end;
end;

procedure TF_ASWSMain.FreePlugins(aCloseInfo: Integer);
begin
  if wasInit then begin
    ShutdownServer(aCloseInfo);
    wasInit := False;
    pgLB.Clear;
  end;
end;

procedure TF_ASWSMain.RxTray1Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  RestoreAndShow;
end;

procedure TF_ASWSMain.B9Click(Sender: TObject);
begin
  CSock.Abort;
end;

procedure TF_ASWSMain.CSockChangeState(Sender: TObject; OldState, NewState: TSocketState);
begin
  case NewState of
    wsClosed,
    wsInvalidState: begin
      B7.Enabled := True;
      B10.Enabled := False;
    end;
    else begin
      B7.Enabled := False;
      B10.Enabled := (NewState = wsConnected);
    end;
  end;
  B9.Enabled := not B7.Enabled;
end;

procedure TF_ASWSMain.B7Click(Sender: TObject);
begin
  with CSock do begin
    Addr := E7.Text;
    Port := E8.Text;
    //FlushTimeout := StrToInt(E9.Text);
    try
      Connect;
    except
      on E:Exception do begin
	ShowMessage(E.Message);
	Abort;
      end;
    end;
  end;
end;

procedure TF_ASWSMain.B10Click(Sender: TObject);
begin
  if (M1.Text <> '') then CSock.Send(@M1.Text[1], Length(M1.Text));
end;

procedure TF_ASWSMain.CSockDataAvailable(Sender: TObject; Error: Word);
const
  BufSize = $10000;
var
  Buf: Pointer;
  lSz: Integer;
  lS : string;
begin
  GetMem(Buf, BufSize);
  lSz := CSock.Receive(Buf, BufSize);
  if (lSz > 0) then begin
    SetLength(lS, lSz);
    Move(Buf^, lS[1], lSz);
    M2.Text := M2.Text + #13#10'===== From Server ===='#13#10 + lS;
  end;
  FreeMem(Buf, BufSize);
end;

procedure TF_ASWSMain.Start1Click(Sender: TObject);
begin
  DoStart;
end;

procedure TF_ASWSMain.Stop1Click(Sender: TObject);
begin
  DoStop;
end;

procedure TF_ASWSMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TF_ASWSMain.B11Click(Sender: TObject);
begin
  RestoreSettings;
end;

function tF_ASWSMain.GetHeader: string;
begin
  Result := Edit10.Text;
end;

function tF_ASWSMain.GetFooter: string;
begin
  Result := Edit11.Text;
end;

procedure TF_ASWSMain.SpeedButton5Click(Sender: TObject);
begin
  if SelectPath(Edit12, 'Select .log file folder') then Edit12.Text := Edit12.Text + 'ASWS.LOG';
end;

procedure TF_ASWSMain.SpeedButton6Click(Sender: TObject);
begin
  SelectPath(Edit14, 'Select folder for uploads');
end;

procedure tF_ASWSMain.RestoreAndShow;
begin
  Application.Restore;
  Application.BringToFront;
  Show;
end;

procedure TF_ASWSMain.Settings1Click(Sender: TObject);
begin
  PC1.ActivePage := TS2;
  PC2.ActivePage := TS5;
  RestoreAndShow;
end;

procedure TF_ASWSMain.B12Click(Sender: TObject);
begin
  M2.Clear;
end;

procedure TF_ASWSMain.PC2Change(Sender: TObject);
begin
  if (MimeLB.Width < 1) then MimeLB.Align := alClient; 
end;

end.

